package com.fp.persistence.pgeneral.report;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEREPORTDETAIL*/
@Entity(name="TgeneReportDetail")
@Table(name="TGENEREPORTDETAIL")
public class TgeneReportDetail extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneReportDetail
*/
@EmbeddedId
private TgeneReportDetailKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="SOURCEPARAMETER", nullable=true)

/**
* Origen de dato del parametro.
*/
private String sourceparameter;

@Column(name="MANDATORY", nullable=true)

/**
* Y Indica que el parametro es obligatorio.
*/
private String mandatory;

/**Contructor por defecto*/
public TgeneReportDetail(){
}
/**Contructor de TgeneReportDetail
@param pPk Clave Primaria del entity
*/
public TgeneReportDetail(TgeneReportDetailKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneReportDetail
*/
public static TgeneReportDetail find(EntityManager pEntityManager,TgeneReportDetailKey pKey) throws Exception{
    TgeneReportDetail obj = pEntityManager.find(TgeneReportDetail.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneReportDetail
@return El objeto que referencia a la Clave primaria de TgeneReportDetail
*/
public TgeneReportDetailKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneReportDetail
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneReportDetail
*/
public void setPk(TgeneReportDetailKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de sourceparameter
@return valor de sourceparameter*/
public String getSourceparameter(){
  return sourceparameter;
}
/**Fija el valor de sourceparameter
@param pSourceparameter nuevo Valor de sourceparameter*/
public void setSourceparameter(String pSourceparameter){
  sourceparameter=pSourceparameter;
}

/**Obtiene el valor de mandatory
@return valor de mandatory*/
public String getMandatory(){
  return mandatory;
}
/**Fija el valor de mandatory
@param pMandatory nuevo Valor de mandatory*/
public void setMandatory(String pMandatory){
  mandatory=pMandatory;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneReportDetail))return false;
    TgeneReportDetail that = (TgeneReportDetail) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneReportDetail
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneReportDetail
*/
public Object createInstance(){
 TgeneReportDetail instance=new TgeneReportDetail();	
 instance.setPk(new TgeneReportDetailKey());
 return instance;
}
/**Clona la entidad TgeneReportDetail
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneReportDetail p=(TgeneReportDetail)this.clone();
  p.setPk((TgeneReportDetailKey)this.pk.cloneMe());
  return p;
}
}
